<h1 id="carousel">Carousel</h1>
<p>Carousel is a set of slides, only one of which is displayed at a time, and buttons used to display the previous or next slide.</p>
<p>Carousel conforms to <a href="https://www.w3.org/WAI/ARIA/apg/patterns/carousel/">W3C's WAI-ARIA authoring practices</a>.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/carousel/carousel';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/carousel/ace-carousel.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/carousel/carousel';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Carousel</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Carousel is instantiated within each <code>&lt;ace-carousel&gt;</code> element and an ID <code>ace-carousel-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-carousel-ready</code> is dispatched to <code>window</code>.</p>
<p>It is strongly recommended that Carousel be provided with an accessible label using <code>aria-label</code> or <code>aria-labelledby</code>. The word &quot;carousel&quot; should not be included in the label as Carousel has <code>aria-roledescription=&quot;carousel&quot;</code> which is read out by screen readers.</p>
<p>Carousels can periodically display the next slide if given the attribute <code>ace-carousel-auto-slide-show</code>. Such automatic Carousels change the slide every 5 seconds by default, however developers can provide a custom interval time in milliseconds as the value of Carousel attribute <code>ace-carousel-auto-slide-show-time</code>. The automatic slide show can be stopped or started using a required, descendant toggle button, or by custom events. Automatic Carousels must have a descendant button to stop and start the automatic slide show, which for better accessibility must be the first focusable descendant. Automatic Carousels will therefore use the first descendant <code>&lt;button&gt;</code> for this and give it the attribute <code>ace-carousel-auto-slide-show-btn</code>. This button will be given an <code>aria-label</code> &quot;Stop automatic slide show&quot; or &quot;Start automatic slide show&quot; when the automatic slide show is running or not respectively. Developers can provide custom or localised strings as values of Carousel attributes <code>ace-carousel-stop-auto-slide-show-label</code> and <code>ace-carousel-start-auto-slide-show-label</code>.</p>
<p>All Carousels, except those with slide picker buttons, must have descendant buttons to display the previous and next slides. Descendant <code>&lt;button&gt;</code> elements with attributes <code>ace-carousel-prev-btn</code> and <code>ace-carousel-next-btn</code> are used. For better accessibility these buttons should be the first and second focusable descendants, or second and third focusable descendants for automatic Carousels. To display these buttons on the left and right sides of the Carousel, as is common practice, CSS should be used. If no descendants have these attributes then the first and second, or second and third for automatic Carousels, descendant <code>&lt;button&gt;</code> elements will be used and given these attributes. The previous slide button will be given an aria-label of value <code>Go to previous slide</code>, or <code>Go to last slide</code> if the Carousel is infinite and the first slide is visible. Developers can however provide custom or localised strings as values of attributes <code>ace-carousel-go-to-prev-slide-label</code> and <code>ace-carousel-go-to-last-slide-label</code> respectively, set on the button. Similarly, the next slide button will be given an aria-label of value <code>Go to next slide</code>, or <code>Go to first slide</code> if the Carousel is infinite and the last slide is visible. Developers can however provide custom or localised strings as values of attributes <code>ace-carousel-go-to-next-slide-label</code> and <code>ace-carousel-go-to-first-slide-label</code> respectively, set on the button.</p>
<p>A set of slide picker buttons, used to select each slide, can be added to Carousel by including an element with attribute <code>ace-carousel-slide-picker</code> and a descendant <code>&lt;button&gt;</code> for each slide. Alternatively, this element can be added with no descendant <code>button</code> elements and Carousel will populate it with a button for each slide. Carousel adds <code>aria-label</code> attributes to each slide picker button in the format <code>Slide n</code>, where <code>n</code> is the slide number. To allow for more approprite or localised strings, the string <code>Slide</code> can be replaced in the <code>aria-label</code> of all slide picker buttons with the value of the attribute <code>ace-carousel-slide-picker-btn-aria-label-prefix</code> of the element with attribute <code>ace-carousel-slide-picker</code>. It is strongly recommended that the slide picker follow the previous and next slide buttons in DOM hierarchy and therefore in tab sequence. This order should be used even if the slide picker buttons are to be displayed below or overlayed on top of the slides in which case their positioning should be set using CSS. For accessibility purposes Carousel buttons that are styled by developers and overlayed on top of the slides must use colors that provides sufficient contrast so they are clearly visible.</p>
<p>All Carousel slides must be descendant within an element with attribute <code>ace-carousel-slides</code>. If no descendant has this attribute, the first child <code>&lt;div&gt;</code> will be used if present, otherwise Carousel will append a child <code>&lt;div&gt;</code> to itself and use it. Slides do not have to be present upon instantiation and can be dynamically added, or removed later, as long as custom event <code>ace-carousel-update-slides</code> is dispatched to the Carousel instance afterwards. Carousel adds <code>aria-label</code> attributes to each slide in the format <code>n of N</code>, where <code>n</code> is the slide number and <code>N</code> is the total number of slides. To allow for localised strings, the string <code>of</code> can be replaced with the value of the attribute <code>ace-carousel-slide-aria-label-infix</code> of the element with attribute <code>ace-carousel-slides</code>.</p>
<h2 id="usage">Usage</h2>
<p>A Carousel displayed slide can be changed using the previous and next slide buttons, using custom events, or by changing the value of its attribute <code>ace-carousel-selected-slide</code> to the slide's number e.g. <code>2</code> will display the second slide and <code>3</code> the third. This attribute can be set before instantiation to display a specific slide on page load, but if omitted Carousel will add it and set its value to <code>1</code> thereby displaying the first slide. The attribute's value is also dynamically updated when the displayed slide is changed using the other methods.</p>
<p>By default the previous and next slide buttons are disabled when the first and last slide is displayed respectively. Giving a Carousel the attribute <code>ace-carousel-infinite</code> allows infinite rotation through slides where clicking the previous button with the first slide displayed will display the last, and clicking the next button with the last slide displayed will display the first. This is an observed attribute that can be added or removed to dynamically enable or disable this behaviour.</p>
<p>For automatic Carousels the automatic slide show is paused while the mouse pointer hovers over the Carousel or while a Carousel instance descendant, other than the automatic slide show toggle button, has keyboard focus, and automatically resumes afterwards. The automatic slide show will not start on page load if the page is hidden, i.e. it's in a background tab or the window is minimised, and will start as soon as the page becomes visible. It will also pause if the page becomes hidden at any point and will resume once the page is visible again.</p>
<p>The automatic slide show can be stopped and started again using the automatic slide show toggle button or using custom events, with both methods setting Carousel attribute <code>ace-carousel-auto-slide-show-stopped</code> to <code>true</code> or <code>false</code>. This attribute can therefore be used to change the text string or icon of the toggle button simply using CSS. Note that this attribute will have value <code>false</code> while the Carousel is temporarily paused due to mouse hover or descendant keyboard focus.</p>
<h2 id="animating-slide-changes">Animating slide changes</h2>
<p>Since animations can be achieved using many different methods Carousel does not animate slide changes. Developers interested in doing so can listen for the <code>ace-carousel-slide-changed</code> custom event and then apply their own animations, as demonstrated in one of the examples below.</p>
<p>In order to implement animations without hindering accessibility developers must hide non-selected slides from screen readers and remove their focusable descendants from the tab sequence after the animation ends, both of which can be achieved by applying CSS declaration <code>display: none</code> or <code>visibility: hidden</code> to them. Furthermore, animations should not be shown to users that have requested the operating system minimise the amount of non-essential motion it uses. To acheive this developers can make use of the <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/@media/prefers-reduced-motion"><code>prefers-reduced-motion</code> media query</a> as demonstrated in the example.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Carousel. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-carousel-slide-picker-btn-size: 12px !default;
$ace-carousel-slide-picker-btn-spacing: $ace-spacing-1 !default;


// STYLES
ace-carousel {
	display: block;
}

[ace-carousel-slide]:not([ace-carousel-slide-selected]) {
	display: none;
}

[ace-carousel-slide-picker-btn] {
	height: $ace-carousel-slide-picker-btn-size;
	margin: 0 calc(#{$ace-carousel-slide-picker-btn-spacing} / 2);

	&amp;[aria-selected=&quot;true&quot;] {
		background-color: $ace-color-selected;
		border-style: inset;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Carousel uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Carousel.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-carousel-ready</code></p>
<p>This event is dispatched when Carousel finishes initialising just after page load, and after dynamically added descendants are initialised in response to the <code>ace-carousel-update-slides</code> custom event being dispatched. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Carousel [string]
}
</code></pre>
<h4 id="selected-slide-changed">Selected slide changed</h4>
<p><code>ace-carousel-selected-slide-changed</code></p>
<p>This event is dispatched when the displayed slide is changed. The event name is available as <code>EVENTS.OUT.SELECTED_SLIDE_CHANGED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'currentlySelectedSlide': // The current selected slide number [number]
	'id': // ID of Carousel [string]
	'previouslySelectedSlide': // The previously selected slide number [number]
}
</code></pre>
<h4 id="automatic-slide-show-events">Automatic slide show events</h4>
<p><code>ace-carousel-auto-slide-show-started</code>, <code>ace-carousel-auto-slide-show-stopped</code> &amp; <code>ace-carousel-auto-slide-show-paused</code></p>
<p>These events are dispatched when the automatic slide show is started, stopped or paused, the latter of which occurs when the mouse pointer hovers over the Carousel or when a descendant, other than the automatic slide show toggle button, has keyboard focus. The event names are available as <code>EVENTS.OUT.AUTO_SLIDE_SHOW_STARTED</code>, <code>EVENTS.OUT.AUTO_SLIDE_SHOW_STOPPED</code> and <code>EVENTS.OUT.AUTO_SLIDE_SHOW_PAUSED</code>, and their <code>detail</code> properties are composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Carousel [string]
}
</code></pre>
<h3 id="listened-for-events">Listened for events</h3>
<p>Carousel listens for the following events that should be dispatched to <code>window</code>.</p>
<h4 id="set-previous-slide">Set previous slide</h4>
<p><code>ace-carousel-set-prev-slide</code></p>
<p>This event should be dispatched to display the previous slide, or the last slide if the Carousel has the attribute <code>ace-carousel-infinite</code> and its first slide is displayed. The event name is available as <code>EVENTS.IN.SET_PREV_SLIDE</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
  'id': // ID of target Carousel [string]
}
</code></pre>
<h4 id="set-next-slide">Set next slide</h4>
<p><code>ace-carousel-set-next-slide</code></p>
<p>This event should be dispatched to display the next slide, or the first slide if the Carousel has the attribute <code>ace-carousel-infinite</code> and its the last slide is displayed. The event name is available as <code>EVENTS.IN.SET_NEXT_SLIDE</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
  'id': // ID of target Carousel [string]
}
</code></pre>
<h4 id="update-slides">Update slides</h4>
<p><code>ace-carousel-update-slides</code></p>
<p>This event should be dispatched when slides are added or removed and causes Carousel to initialise them and then dispatch the <code>ace-carousel-ready</code> event. The event name is available as <code>EVENTS.IN.UPDATE_SLIDES</code> and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
  'id': // ID of target Carousel [string]
}
</code></pre>
<h4 id="automatic-slide-show-events-1">Automatic slide show events</h4>
<p><code>ace-carousel-start-auto-slide-show</code> &amp; <code>ace-carousel-stop-auto-slide-show</code></p>
<p>These event should be dispatched to start or stop the automatic slide show. The event names are available as <code>EVENTS.IN.START_AUTO_SLIDE_SHOW</code> and <code>EVENTS.IN.STOP_AUTO_SLIDE_SHOW</code> and their <code>detail</code> properties should be composed as follows:</p>
<pre><code class="language-js">'detail': {
  'id': // ID of target Carousel [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-carousel">Simple Carousel</h3>
<p>Simple Carousel with 3 slides.</p>
<div class="example-block"><ace-carousel aria-label="Simple">
	<button>Previous slide</button>
	<button>Next slide</button>
	<div>
		<div>
			<h3>Slide 1 heading</h3>
			<p>Slide 1 content.</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
		<div>
			<h3>Slide 2 heading</h3>
			<p>Slide 2 content.</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
		<div>
			<h3>Slide 3 heading</h3>
			<p>Slide 3 content.</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;ace-carousel aria-label=&quot;Simple&quot;&gt;
	&lt;button&gt;Previous slide&lt;/button&gt;
	&lt;button&gt;Next slide&lt;/button&gt;
	&lt;div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<h3 id="carousel-controlled-using-custom-events">Carousel controlled using custom events</h3>
<p>The buttons in this example dispatch the <code>ace-carousel-set-prev-slide</code>, <code>ace-carousel-set-next-slide</code> and <code>ace-carousel-update-slides</code> custom events on the Carousel. The JavaScript used by this example is shown below.</p>
<div class="example-block"><p>These buttons dispatch custom events</p>
<button id="prev-slide-btn">Prev slide</button>
<button id="next-slide-btn">Next slide</button>
<button id="add-slide-btn">Add slide to end</button>
<button id="remove-slide-btn">Remove last slide</button>
<hr>
<ace-carousel aria-label="Custom events" id="ace-custom-events-carousel">
	<button>Previous slide</button>
	<button>Next slide</button>
	<div>
		<div>
			<h3>Slide 1 heading</h3>
			<p>Slide 1 content.</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
		<div>
			<h3>Slide 2 heading</h3>
			<p>Slide 2 content.</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
		<div>
			<h3>Slide 3 heading</h3>
			<p>Slide 3 content.</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;p&gt;These buttons dispatch custom events&lt;/p&gt;
&lt;button id=&quot;prev-slide-btn&quot;&gt;Prev slide&lt;/button&gt;
&lt;button id=&quot;next-slide-btn&quot;&gt;Next slide&lt;/button&gt;
&lt;button id=&quot;add-slide-btn&quot;&gt;Add slide to end&lt;/button&gt;
&lt;button id=&quot;remove-slide-btn&quot;&gt;Remove last slide&lt;/button&gt;
&lt;hr&gt;
&lt;ace-carousel aria-label=&quot;Custom events&quot; id=&quot;ace-custom-events-carousel&quot;&gt;
	&lt;button&gt;Previous slide&lt;/button&gt;
	&lt;button&gt;Next slide&lt;/button&gt;
	&lt;div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<pre><code class="language-js">import {ATTRS, EVENTS} from '/ace/components/carousel/carousel.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const CAROUSEL_ID = 'ace-custom-events-carousel';
	const carouselEl = document.getElementById(CAROUSEL_ID);
	const slidesWrapper = carouselEl.querySelector(`[${ATTRS.SLIDES}]`);

	const addSlide = () =&gt; {
		const headingEl = document.createElement('h2');
		headingEl.textContent = `Dynamically added Slide`;
		const p = document.createElement('p');
		p.textContent = `This slide was added dynamically, after this Carousel was initialised.`;
		const newSlideEl = document.createElement('div');
		newSlideEl.appendChild(headingEl);
		newSlideEl.appendChild(p);
		slidesWrapper.appendChild(newSlideEl);
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.UPDATE_SLIDES,
			{'detail': {'id': CAROUSEL_ID}},
		));
	};

	window.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		switch(targetId) {
			case 'prev-slide-btn':
			case 'next-slide-btn': {
				const event = EVENTS.IN[`SET_${targetId === 'prev-slide-btn' ? 'PREV' : 'NEXT'}_SLIDE`];
				window.dispatchEvent(new CustomEvent(
					event,
					{'detail': {'id': CAROUSEL_ID}},
				));
				break;
			}
			case 'add-slide-btn':
			case 'remove-slide-btn':
				if (targetId === 'add-slide-btn') {
					addSlide();
				} else {
					slidesWrapper.removeChild(slidesWrapper.lastElementChild);
				}
				window.dispatchEvent(new CustomEvent(
					EVENTS.IN.UPDATE_SLIDES,
					{'detail': {'id': CAROUSEL_ID}},
				));
				break;
		}
	});
});
</code></pre>
<h3 id="carousel-with-infinite-rotation-and-second-slide-initially-displayed">Carousel with infinite rotation and second slide initially displayed</h3>
<p>Carousel with infinite rotation that displays the second slide upon page load.</p>
<div class="example-block"><ace-carousel ace-carousel-infinite ace-carousel-selected-slide="2" aria-label="Infinite rotation and second slide initially displayed" id="ace-infinite-carousel">
	<button>Previous slide</button>
	<button>Next slide</button>
	<div>
		<div>
			<h3>Slide 1 heading</h3>
			<p>Slide 1 content.</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
		<div>
			<h3>Slide 2 heading</h3>
			<p>Slide 2 content.</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
		<div>
			<h3>Slide 3 heading</h3>
			<p>Slide 3 content.</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;ace-carousel ace-carousel-infinite ace-carousel-selected-slide=&quot;2&quot; aria-label=&quot;Infinite rotation and second slide initially displayed&quot; id=&quot;ace-infinite-carousel&quot;&gt;
	&lt;button&gt;Previous slide&lt;/button&gt;
	&lt;button&gt;Next slide&lt;/button&gt;
	&lt;div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<h3 id="carousel-with-slide-picker">Carousel with slide picker</h3>
<p>Carousel with slide picker buttons and automatic slide show. Note: Previous and next slide buttons are optional when slide picker buttons are present.</p>
<div class="example-block"><ace-carousel aria-label="Slide picker" id="ace-slide-picker-carousel">
	<div ace-carousel-slide-picker></div>
	<div>
		<div>
			<h3>Slide 1 heading</h3>
			<p>Slide 1 content.</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
		<div>
			<h3>Slide 2 heading</h3>
			<p>Slide 2 content.</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
		<div>
			<h3>Slide 3 heading</h3>
			<p>Slide 3 content.</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;ace-carousel aria-label=&quot;Slide picker&quot; id=&quot;ace-slide-picker-carousel&quot;&gt;
	&lt;div ace-carousel-slide-picker&gt;&lt;/div&gt;
	&lt;div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<h3 id="carousel-with-automatic-slide-show">Carousel with automatic slide show</h3>
<p>Carousel with automatic slide show. Two buttons have also been included, which dispatch the <code>ace-carousel-start-auto-slide-show</code> &amp; <code>ace-carousel-stop-auto-slide-show</code> custom events. The JavaScript used by this example is shown below.</p>
<div class="example-block"><button id="stop-auto-slide-show-custom-event-btn">Stop automatic slide show custom event</button>
<button id="start-auto-slide-show-custom-event-btn">Start automatic slide show custom event</button>
<hr>
<ace-carousel ace-carousel-auto-slide-show ace-carousel-auto-slide-show-time="2000" ace-carousel-infinite aria-label="Automatic slide show" id="ace-auto-carousel">
	<button>Toggle automatic slide show</button>
	<button>Previous slide</button>
	<button>Next slide</button>
	<div>
		<div>
			<h3>Slide 1 heading</h3>
			<p><a href="http://ace.p.ota.to">ACE home page</a></p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo"/>
		</div>
		<div>
			<h3>Slide 2 heading</h3>
			<p><a href="http://ace.p.ota.to">ACE home page</a></p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone"/>
		</div>
		<div>
			<h3>Slide 3 heading</h3>
			<p><a href="http://ace.p.ota.to">ACE home page</a></p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles"/>
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;button id=&quot;stop-auto-slide-show-custom-event-btn&quot;&gt;Stop automatic slide show custom event&lt;/button&gt;
&lt;button id=&quot;start-auto-slide-show-custom-event-btn&quot;&gt;Start automatic slide show custom event&lt;/button&gt;
&lt;hr&gt;
&lt;ace-carousel ace-carousel-auto-slide-show ace-carousel-auto-slide-show-time=&quot;2000&quot; ace-carousel-infinite aria-label=&quot;Automatic slide show&quot; id=&quot;ace-auto-carousel&quot;&gt;
	&lt;button&gt;Toggle automatic slide show&lt;/button&gt;
	&lt;button&gt;Previous slide&lt;/button&gt;
	&lt;button&gt;Next slide&lt;/button&gt;
	&lt;div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;&lt;a href=&quot;http://ace.p.ota.to&quot;&gt;ACE home page&lt;/a&gt;&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;&lt;a href=&quot;http://ace.p.ota.to&quot;&gt;ACE home page&lt;/a&gt;&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot;/&gt;
		&lt;/div&gt;
		&lt;div&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;&lt;a href=&quot;http://ace.p.ota.to&quot;&gt;ACE home page&lt;/a&gt;&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot;/&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<pre><code class="language-js">import {EVENTS} from '/ace/components/carousel/carousel.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const CAROUSEL_ID = 'ace-auto-carousel';

	window.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		switch(targetId) {
			case 'start-auto-slide-show-custom-event-btn':
			case 'stop-auto-slide-show-custom-event-btn': {
				const event = EVENTS.IN[`${targetId === 'start-auto-slide-show-custom-event-btn' ? 'START' : 'STOP'}_AUTO_SLIDE_SHOW`];
				window.dispatchEvent(new CustomEvent(
					event,
					{'detail': {'id': CAROUSEL_ID}},
				));
				break;
			}
		}
	});
});
</code></pre>
<h3 id="animated-carousel">Animated Carousel</h3>
<p>Example of Carousel with animated slide changes. Custom styles have been applied to this example and are shown below. The JavaScript used by this example is shown below.</p>
<div class="example-block"><ace-carousel ace-carousel-infinite aria-label="Animated" id="ace-animated-carousel" class="ace-animated-carousel">
	<button>Previous slide</button>
	<button>Next slide</button>
	<div class="ace-animated-carousel__slides">
		<div class="ace-animated-carousel__slide">
			<h3>Slide 1 heading</h3>
			<p>Slide 1 content.</p>
			<p>
				<button>Button</button>
				<a href="#">Link</a>
			</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo" />
		</div>
		<div class="ace-animated-carousel__slide">
			<h3>Slide 2 heading</h3>
			<p>Slide 2 content.</p>
			<p>
				<button>Button</button>
				<a href="#">Link</a>
			</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
		</div>
		<div class="ace-animated-carousel__slide">
			<h3>Slide 3 heading</h3>
			<p>Slide 3 content.</p>
			<p>
				<button>Button</button>
				<a href="#">Link</a>
			</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;ace-carousel ace-carousel-infinite aria-label=&quot;Animated&quot; id=&quot;ace-animated-carousel&quot; class=&quot;ace-animated-carousel&quot;&gt;
	&lt;button&gt;Previous slide&lt;/button&gt;
	&lt;button&gt;Next slide&lt;/button&gt;
	&lt;div class=&quot;ace-animated-carousel__slides&quot;&gt;
		&lt;div class=&quot;ace-animated-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;p&gt;
				&lt;button&gt;Button&lt;/button&gt;
				&lt;a href=&quot;#&quot;&gt;Link&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
		&lt;/div&gt;
		&lt;div class=&quot;ace-animated-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;p&gt;
				&lt;button&gt;Button&lt;/button&gt;
				&lt;a href=&quot;#&quot;&gt;Link&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
		&lt;/div&gt;
		&lt;div class=&quot;ace-animated-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;p&gt;
				&lt;button&gt;Button&lt;/button&gt;
				&lt;a href=&quot;#&quot;&gt;Link&lt;/a&gt;
			&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<pre><code class="language-scss">@media (prefers-reduced-motion: no-preference) {
	.ace-animated-carousel {
		&amp;__slides {
			display: flex;
			overflow-x: hidden;
		}

		&amp;__slide {
			flex-shrink: 0;
			width: 100%;

			&amp;--hidden {
				visibility: hidden;
			}

			&amp;:not([ace-carousel-slide-selected]) {
				display: block;
			}
		}
	}
}
</code></pre>
<pre><code class="language-js">import { ATTRS, EVENTS } from '/ace/components/carousel/carousel.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	// If user prefers reduced motion then do not animate
	if (!window.matchMedia('(prefers-reduced-motion: no-preference)').matches) {
		return;
	}

	const CAROUSEL_ID = 'ace-animated-carousel';
	const carouselEl = document.getElementById(CAROUSEL_ID);
	const carouselSlidesEl = carouselEl.querySelector(`[${ATTRS.SLIDES}]`);
	const carouselSlideEls = carouselEl.querySelectorAll(`[${ATTRS.SLIDE}]`);
	const slidesEdges = [];
	let selectedSlideIndex = +carouselEl.getAttribute(ATTRS.SELECTED_SLIDE) - 1;
	let scrollTimeout;

	// Hide non-selected slides on page load
	carouselSlideEls.forEach((slide, i) =&gt; {
		if (i === selectedSlideIndex) {
			return;
		}
		slide.setAttribute('aria-hidden', 'true');
		slide.classList.add(`${CAROUSEL_ID}__slide--hidden`);
	});

	// Store left edge x-coordinates of slides on page load and resize
	const getSlidesEdges = () =&gt; {
		carouselSlideEls.forEach((slide, i) =&gt; slidesEdges[i] = slide.offsetLeft - carouselSlidesEl.offsetLeft);
	};
	window.addEventListener('load', getSlidesEdges);
	window.addEventListener('resize', getSlidesEdges, { passive: true });

	// Start animation when slide changes
	window.addEventListener(EVENTS.OUT.SELECTED_SLIDE_CHANGED, (e) =&gt; {
		if (!e.detail || e.detail.id !== CAROUSEL_ID) {
			return;
		}
		clearTimeout(scrollTimeout);
		selectedSlideIndex = e.detail.currentlySelectedSlide - 1;
		carouselSlideEls.forEach((slide) =&gt; {
			// Prevent non-selected slides from being announced by screen reader due to aria-live=&quot;polite&quot; on carouselSlidesEl
			slide.setAttribute('aria-hidden', 'true');
			slide.classList.remove(`${CAROUSEL_ID}__slide--hidden`);
		});
		carouselSlidesEl.scrollTo({ behavior: 'smooth', left: slidesEdges[selectedSlideIndex] });
	});

	// Hide non-selected slides when scrolling finishes
	carouselSlidesEl.addEventListener('scroll', () =&gt; {
		clearTimeout(scrollTimeout);
		scrollTimeout = setTimeout(() =&gt; {
			carouselSlideEls.forEach((slide, i) =&gt; {
				if (i === selectedSlideIndex) {
					slide.removeAttribute('aria-hidden');
					return;
				}
				slide.classList.add(`${CAROUSEL_ID}__slide--hidden`);
			});
		}, 100);
	}, { passive: true });
});
</code></pre>
<h3 id="styled-carousel">Styled Carousel</h3>
<p>An example of how Carousel can be styled to resemble a commonly used design. Custom styles have been applied to this example and are shown below. The JavaScript used by this example is shown below.</p>
<div class="example-block"><ace-carousel ace-carousel-auto-slide-show ace-carousel-infinite aria-label="Styled example" id="ace-styled-carousel"
	class="ace-styled-carousel">
	<button class="ace-styled-carousel__auto-slide-show-btn"><span class="play-icon">&#9658;</span><span
			class="pause-icon">&#10074; &#10074;</span></button>
	<button class="ace-styled-carousel__slide-btn ace-styled-carousel__slide-btn--prev">&#10094;</button>
	<button class="ace-styled-carousel__slide-btn ace-styled-carousel__slide-btn--next">&#10095;</button>
	<div ace-carousel-slide-picker class="ace-styled-carousel__slide-picker"></div>
	<div class="ace-styled-carousel__slides">
		<div class="ace-styled-carousel__slide">
			<h3>Slide 1 heading</h3>
			<button>Button</button>
			<p>Slide 1 content.</p>
			<img src="/img/logo.svg" height="100px" alt="Potato logo" />
		</div>
		<div class="ace-styled-carousel__slide">
			<h3>Slide 2 heading</h3>
			<button>Button</button>
			<p>Slide 2 content.</p>
			<img src="/img/phone-spuddy.png" height="100px" alt="Potato Spuddy with headphones and phone" />
		</div>
		<div class="ace-styled-carousel__slide">
			<h3>Slide 3 heading</h3>
			<button>Button</button>
			<p>Slide 3 content.</p>
			<img src="/img/goggles-spuddy.png" height="100px" alt="Potato Spuddy with virtual reality goggles" />
		</div>
	</div>
</ace-carousel>
</div>
<pre><code class="language-html">&lt;ace-carousel ace-carousel-auto-slide-show ace-carousel-infinite aria-label=&quot;Styled example&quot; id=&quot;ace-styled-carousel&quot;
	class=&quot;ace-styled-carousel&quot;&gt;
	&lt;button class=&quot;ace-styled-carousel__auto-slide-show-btn&quot;&gt;&lt;span class=&quot;play-icon&quot;&gt;&amp;#9658;&lt;/span&gt;&lt;span
			class=&quot;pause-icon&quot;&gt;&amp;#10074; &amp;#10074;&lt;/span&gt;&lt;/button&gt;
	&lt;button class=&quot;ace-styled-carousel__slide-btn ace-styled-carousel__slide-btn--prev&quot;&gt;&amp;#10094;&lt;/button&gt;
	&lt;button class=&quot;ace-styled-carousel__slide-btn ace-styled-carousel__slide-btn--next&quot;&gt;&amp;#10095;&lt;/button&gt;
	&lt;div ace-carousel-slide-picker class=&quot;ace-styled-carousel__slide-picker&quot;&gt;&lt;/div&gt;
	&lt;div class=&quot;ace-styled-carousel__slides&quot;&gt;
		&lt;div class=&quot;ace-styled-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 1 heading&lt;/h3&gt;
			&lt;button&gt;Button&lt;/button&gt;
			&lt;p&gt;Slide 1 content.&lt;/p&gt;
			&lt;img src=&quot;/img/logo.svg&quot; height=&quot;100px&quot; alt=&quot;Potato logo&quot; /&gt;
		&lt;/div&gt;
		&lt;div class=&quot;ace-styled-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 2 heading&lt;/h3&gt;
			&lt;button&gt;Button&lt;/button&gt;
			&lt;p&gt;Slide 2 content.&lt;/p&gt;
			&lt;img src=&quot;/img/phone-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with headphones and phone&quot; /&gt;
		&lt;/div&gt;
		&lt;div class=&quot;ace-styled-carousel__slide&quot;&gt;
			&lt;h3&gt;Slide 3 heading&lt;/h3&gt;
			&lt;button&gt;Button&lt;/button&gt;
			&lt;p&gt;Slide 3 content.&lt;/p&gt;
			&lt;img src=&quot;/img/goggles-spuddy.png&quot; height=&quot;100px&quot; alt=&quot;Potato Spuddy with virtual reality goggles&quot; /&gt;
		&lt;/div&gt;
	&lt;/div&gt;
&lt;/ace-carousel&gt;
</code></pre>
<pre><code class="language-scss">.ace-styled-carousel {
	color: #fff;
	max-width: 600px;
	position: relative;

	&amp;__auto-slide-show-btn,
	&amp;__slide-btn {
		background: transparent;
		border: 2px solid #fff;
		border-radius: 50%;
		color: inherit;
		cursor: pointer;
		height: 45px;
		margin: 8px;
		position: absolute;
		width: 45px;

		&amp;:focus,
		&amp;:hover {
			background: #00bed0;
		}

		&amp;:focus {
			outline: none;
		}
	}

	&amp;[ace-carousel-auto-slide-show-stopped=&quot;true&quot;] .pause-icon,
	&amp;[ace-carousel-auto-slide-show-stopped=&quot;false&quot;] .play-icon {
		display: none;
	}

	&amp;__slide-btn {
		border-radius: 50%;
		font-size: 24px;
		top: 50%;
		transform: translateY(-50%);

		&amp;--next {
			right: 0;
		}
	}

	&amp;__slide-picker {
		bottom: 0;
		left: 50%;
		position: absolute;
		transform: translateX(-50%);
	}

	[ace-carousel-slide-picker-btn] {
		$slide-picker-btn-diameter: 10px;

		background-color: transparent;
		border: 2px solid transparent;
		border-radius: 50%;
		cursor: pointer;
		height: $slide-picker-btn-diameter * 2.5;
		margin: 0;
		position: relative;
		width: $slide-picker-btn-diameter * 2.5;

		&amp;:active,
		&amp;:focus {
			border-color: #fff;
			outline: none;
		}

		&amp;::after {
			border: 1px solid #fff;
			border-radius: 50%;
			content: '';
			height: $slide-picker-btn-diameter;
			left: 50%;
			position: absolute;
			top: 50%;
			transform: translate(-50%, -50%);
			width: $slide-picker-btn-diameter;
		}

		&amp;:hover::after {
			background: #00bed0;
		}

		&amp;[aria-selected=&quot;true&quot;]::after {
			background-color: #fff;
		}
	}

	&amp;__slide {
		padding: 50px 80px 30px;

		$bg-colors: #173d57, #66204a, #20122e;
		@for $i from 1 through length($bg-colors) {
			&amp;:nth-of-type(#{$i}) {
				background: nth($bg-colors, $i);
			}
		}
	}

	// Animation styles
	@media (prefers-reduced-motion: no-preference) {
		&amp;__slides {
			display: flex;
			overflow-x: hidden;
		}

		&amp;__slide {
			flex-shrink: 0;
			width: 100%;

			&amp;--hidden {
				visibility: hidden;
			}

			&amp;:not([ace-carousel-slide-selected]) {
				display: block;
			}
		}
	}
}
</code></pre>
<pre><code class="language-js">import { ATTRS, EVENTS } from '/ace/components/carousel/carousel.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	// If user prefers reduced motion then do not animate
	if (!window.matchMedia('(prefers-reduced-motion: no-preference)').matches) {
		return;
	}

	const CAROUSEL_ID = 'ace-styled-carousel';
	const carouselEl = document.getElementById(CAROUSEL_ID);
	const carouselSlidesEl = carouselEl.querySelector(`[${ATTRS.SLIDES}]`);
	const carouselSlideEls = carouselEl.querySelectorAll(`[${ATTRS.SLIDE}]`);
	const slidesEdges = [];
	let selectedSlideIndex = +carouselEl.getAttribute(ATTRS.SELECTED_SLIDE) - 1;
	let scrollTimeout;

	// Hide non-selected slides on page load
	carouselSlideEls.forEach((slide, i) =&gt; {
		if (i === selectedSlideIndex) {
			return;
		}
		slide.setAttribute('aria-hidden', 'true');
		slide.classList.add(`${CAROUSEL_ID}__slide--hidden`);
	});

	// Store left edge x-coordinates of slides on page load and resize
	const getSlidesEdges = () =&gt; {
		carouselSlideEls.forEach((slide, i) =&gt; slidesEdges[i] = slide.offsetLeft - carouselSlidesEl.offsetLeft);
	};
	window.addEventListener('load', getSlidesEdges);
	window.addEventListener('resize', getSlidesEdges, { passive: true });

	// Start animation when slide changes
	window.addEventListener(EVENTS.OUT.SELECTED_SLIDE_CHANGED, (e) =&gt; {
		if (!e.detail || e.detail.id !== CAROUSEL_ID) {
			return;
		}
		clearTimeout(scrollTimeout);
		selectedSlideIndex = e.detail.currentlySelectedSlide - 1;
		carouselSlideEls.forEach((slide) =&gt; {
			// Prevent non-selected slides from being announced by screen reader due to aria-live=&quot;polite&quot; on carouselSlidesEl
			slide.setAttribute('aria-hidden', 'true');
			slide.classList.remove(`${CAROUSEL_ID}__slide--hidden`);
		});
		carouselSlidesEl.scrollTo({ behavior: 'smooth', left: slidesEdges[selectedSlideIndex] });
	});

	// Hide non-selected slides when scrolling finishes
	carouselSlidesEl.addEventListener('scroll', () =&gt; {
		clearTimeout(scrollTimeout);
		scrollTimeout = setTimeout(() =&gt; {
			carouselSlideEls.forEach((slide, i) =&gt; {
				if (i === selectedSlideIndex) {
					slide.removeAttribute('aria-hidden');
					return;
				}
				slide.classList.add(`${CAROUSEL_ID}__slide--hidden`);
			});
		}, 100);
	}, { passive: true });
});
</code></pre>
